﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Wpf;

namespace ThinkGeoGis.GisCore
{
    public class PathAnuimationOverylay : PathOverylay
    {
        public SolidColorBrush AnimationPathBrush;
        public double AnimationPathThick;
        public string AnimationPathData;

        public double AnimationPathWidth;
        public double AnimationPathHeight;
        public GeoCollection<Path> AnimationPath;
        public PathAnuimationOverylay()
        {
            AnimationPath = new GeoCollection<Path>();
            AnimationPathData = "M1705.06,1318.313v-89.254l-319.9-221.799l0.073-208.063c0.521-84.662-26.629-121.796-63.961-121.491c-37.332-0.305-64.482,36.829-63.961,121.491l0.073,208.063l-319.9,221.799v89.254l330.343-157.288l12.238,241.308l-134.449,92.931l0.531,42.034l175.125-42.917l175.125,42.917l0.531-42.034l-134.449-92.931l12.238-241.308L1705.06,1318.313z";
            AnimationPathBrush = Brushes.Blue;
            AnimationPathThick = 2;
            AnimationPathWidth = 20;
            AnimationPathHeight = 20;

        }

        public override void StartAnimation()
        {
            if (AnimationPath.Count > 0) return;
            AnimationPath.Clear();
            for (int i = 0; i < base.Paths.Count; i++)
            {
                Storyboard story = new Storyboard();
                Path animationPath = new Path();
                animationPath.Stroke = AnimationPathBrush;
                animationPath.StrokeThickness = AnimationPathThick;
                animationPath.Width = AnimationPathWidth;
                animationPath.Data = PathGeometry.CreateFromGeometry(Geometry.Parse("M1705.06,1318.313v-89.254l-319.9-221.799l0.073-208.063c0.521-84.662-26.629-121.796-63.961-121.491c-37.332-0.305-64.482,36.829-63.961,121.491l0.073,208.063l-319.9,221.799v89.254l330.343-157.288l12.238,241.308l-134.449,92.931l0.531,42.034l175.125-42.917l175.125,42.917l0.531-42.034l-134.449-92.931l12.238-241.308L1705.06,1318.313z"));
                AnimationPath.Add(animationPath);
                base.OverlayCanvas.Children.Add(animationPath);
                Canvas.SetTop(animationPath, animationPath.Width/2);
                Canvas.SetLeft(animationPath, animationPath.Height/2);

                animationPath.RenderTransformOrigin = new Point(0.5, 0.5);

                MatrixTransform matrix = new MatrixTransform();
                animationPath.RenderTransform = matrix;

                NameScope.SetNameScope(base.OverlayCanvas, new NameScope());
                base.OverlayCanvas.RegisterName("matrix" + i.ToString(), matrix);

                MatrixAnimationUsingPath matrixAnimation = new MatrixAnimationUsingPath();
                matrixAnimation.PathGeometry = Paths[i].gisPath.Data.GetFlattenedPathGeometry();
                matrixAnimation.Duration = new Duration(TimeSpan.FromSeconds(2));
                matrixAnimation.RepeatBehavior = RepeatBehavior.Forever;
                matrixAnimation.AutoReverse = true;
                matrixAnimation.IsOffsetCumulative = false;
                matrixAnimation.DoesRotateWithTangent = true;//旋转
                story.Children.Add(matrixAnimation);
                Storyboard.SetTargetName(matrixAnimation, "matrix" + i.ToString());
                Storyboard.SetTargetProperty(matrixAnimation, new PropertyPath(MatrixTransform.MatrixProperty));
                story.Begin(base.OverlayCanvas);
            }
 
        }
    }
}
